Subject: [PATCH v2] grep: clarify what `grep.patternType=default` means

From: Junio C Hamano <[email-masked]>
Date: Sun, 05 Dec 2021 12:26:16 -0800

We documented that with grep.patternType set to default, the "git
grep" command returns to "the default matching behavior" in 84befcd0
(grep: add a grep.patternType configuration setting, 2012-08-03).

The grep.extendedRegexp configuration variable was the only way to
configure the behavior before that, after b22520a3 (grep: allow -E
and -n to be turned on by default via configuration, 2011-03-30)
introduced it.

It is understandable that we referred to the behavior that honors
the older configuration variable as "the default matching"
behavior.  It is fairly clear in its log message:

    When grep.patternType is set to a value other than "default", the
    grep.extendedRegexp setting is ignored. The value of "default" restores
    the current default behavior, including the grep.extendedRegexp
    behavior.

But when the paragraph is read in isolation by a new person who is
not aware of that backstory (which is the synonym for "most users"),
the "default matching behavior" can be read as "how 'git grep'
behaves without any configuration variables or options", which is
"match the pattern as BRE".

Clarify what the passage means by elaborating what the phrase
"default matching behavior" wanted to mean.

Helped-by: Johannes Altmanninger <[email-masked]>
Signed-off-by: Junio C Hamano <[email-masked]>
---

1:  39afc16050 ! 1:  b6a542173b grep: clarify what `grep.patternType=default` means
    @@ Metadata
      ## Commit message ##
         grep: clarify what `grep.patternType=default` means
     
    -    Back in the days when the "return to the default matching behavior"
    -    part was written in 84befcd0 (grep: add a grep.patternType
    -    configuration setting, 2012-08-03), grep.extendedRegexp was the only
    -    way to configure the behaviour since b22520a3 (grep: allow -E and -n
    -    to be turned on by default via configuration, 2011-03-30).
    +    We documented that with grep.patternType set to default, the "git
    +    grep" command returns to "the default matching behavior" in 84befcd0
    +    (grep: add a grep.patternType configuration setting, 2012-08-03).
     
    -    It was understandable that we referred to the behaviour that honors
    +    The grep.extendedRegexp configuration variable was the only way to
    +    configure the behavior before that, after b22520a3 (grep: allow -E
    +    and -n to be turned on by default via configuration, 2011-03-30)
    +    introduced it.
    +
    +    It is understandable that we referred to the behavior that honors
         the older configuration variable as "the default matching"
    -    behaviour.  It is fairly clear in its log message:
    +    behavior.  It is fairly clear in its log message:
     
             When grep.patternType is set to a value other than "default", the
             grep.extendedRegexp setting is ignored. The value of "default" restores
    @@ Commit message
     
         But when the paragraph is read in isolation by a new person who is
         not aware of that backstory (which is the synonym for "most users"),
    -    the "default matching behaviour" can be read as "how 'git grep'
    +    the "default matching behavior" can be read as "how 'git grep'
         behaves without any configuration variables or options", which is
         "match the pattern as BRE".
     
         Clarify what the passage means by elaborating what the phrase
    -    "default matching behaviour" wanted to mean.
    +    "default matching behavior" wanted to mean.
     
    +    Helped-by: Johannes Altmanninger <[email-masked]>
         Signed-off-by: Junio C Hamano <[email-masked]>
     
      ## Documentation/config/grep.txt ##
    @@ Documentation/config/grep.txt: grep.patternType::
      	'fixed', or 'perl' will enable the `--basic-regexp`, `--extended-regexp`,
      	`--fixed-strings`, or `--perl-regexp` option accordingly, while the
     -	value 'default' will return to the default matching behavior.
    -+	value 'default' will use the settings of `grep.extendedRegexp` option
    -+	to choose between `basic` and `extended`.
    ++	value 'default' will use the `grep.extendedRegexp` option to choose
    ++	between 'basic' and 'extended'.
      
      grep.extendedRegexp::
      	If set to true, enable `--extended-regexp` option by default. This

 Documentation/config/grep.txt | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/Documentation/config/grep.txt b/Documentation/config/grep.txt
index 44abe45a7c..182edd813a 100644
--- a/Documentation/config/grep.txt
+++ b/Documentation/config/grep.txt
@@ -8,7 +8,8 @@ grep.patternType::
 	Set the default matching behavior. Using a value of 'basic', 'extended',
 	'fixed', or 'perl' will enable the `--basic-regexp`, `--extended-regexp`,
 	`--fixed-strings`, or `--perl-regexp` option accordingly, while the
-	value 'default' will return to the default matching behavior.
+	value 'default' will use the `grep.extendedRegexp` option to choose
+	between 'basic' and 'extended'.
 
 grep.extendedRegexp::
 	If set to true, enable `--extended-regexp` option by default. This
-- 
2.34.1-308-g0a2b0356a8